#!/bin/bash
#---
# Excerpted from "Scalable Cloud Ops with Fugue",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/fugue for more book information.
#---

KEY=/refuge/locks/restart
VALUE=$(hostname)
TIMEOUT=60

# Obtain Lock
until vars put --if-none-match --ttl $TIMEOUT $KEY $VALUE >/dev/null 2>&1; do
  echo "Waiting on $(vars get $KEY)" >> /var/log/refuge/vars-watch.log
  sleep 2
done
echo "Acquired lock: $(vars get $KEY)" >> /var/log/refuge/vars-watch.log

# Release Lock on Exit
trap "vars delete $KEY >/dev/null 2>&1"  EXIT

/home/ubuntu/scripts/refuge-restart.sh

echo "Releasing lock: $(vars get $KEY)" >> /var/log/refuge/vars-watch.log
